package com.steerinfo.baseinfo.meterbaserfidinfo.controller;

import com.steerinfo.baseinfo.meterbaserfidinfo.mapper.MeterBaseRfidInfoMapper;
import com.steerinfo.baseinfo.meterbaserfidinfo.model.MeterBaseRfidInfo;
import com.steerinfo.baseinfo.meterbaserfidinfo.service.IMeterBaseRfidInfoService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseRfidInfo RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-04-07 10:21
 * 类描述
 * 修订历史：
 * 日期：2022-04-07
 * 作者：generator
 * 参考：
 * 描述：MeterBaseRfidInfo RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterbaserfidinfos")
public class MeterBaseRfidInfoController extends BaseRESTfulController {

    @Autowired
    IMeterBaseRfidInfoService meterBaseRfidInfoService;

    @Resource
    MeterBaseRfidInfoMapper meterBaseRfidInfoMapper;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserfidinfo:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRfidInfo> list = meterBaseRfidInfoService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserfidinfo:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRfidInfo> list = meterBaseRfidInfoService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="倒序获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbaserfidinfo:view")
    @GetMapping(value = "/likeByDesc/")
    public RESTfulResult likeByDesc(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterBaseRfidInfo> list = meterBaseRfidInfoService.likeByDesc(parmas, pageNum, pageSize);
        return success(list);
    }


    @ApiOperation(value="倒序获取列表", notes="分页模糊查询")
    //@RequiresPermissions("meterbaserfidinfo:view")
    @PostMapping(value = "/carNoByNoPage")
    public RESTfulResult carNoByNoPage(@RequestBody(required = false) HashMap parmas){
        List<String> list = meterBaseRfidInfoService.carNoByNoPage(parmas);
        return success(list);
    }

    @ApiOperation(value="创建", notes="根据MeterBaseRfidInfo对象创建")
    @ApiImplicitParam(name = "meterBaseRfidInfo", value = "详细实体meterBaseRfidInfo", required = true, dataType = "MeterBaseRfidInfo")
    //@RequiresPermissions("meterbaserfidinfo:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestParam MeterBaseRfidInfo model){
        MeterBaseRfidInfo meterBaseRfidInfo = meterBaseRfidInfoService.add(model);
        return success(meterBaseRfidInfo);
    }

    @ApiOperation(value="根据rfid和carNo新增对象", notes="根据rfid和carNo新增对象")
    @PostMapping(value = "/checkAndAdd")
    public RESTfulResult checkAndAdd(@RequestBody HashMap model){
        RESTfulResult rm = failed();
        String rfidCode = model.get("rfidCode") == null ? "" : model.get("rfidCode").toString();
        String carNo = model.get("carNo") == null ? "" : model.get("carNo").toString();
        if(com.steerinfo.util.StringUtils.isEmpty(rfidCode)) {
            rm.setMessage("rfid编号不能为空，请确认！！");
            return rm;
        }
        if(com.steerinfo.util.StringUtils.isEmpty(carNo)) {
            rm.setMessage("车号不能为空，请确认！！");
            return rm;
        }
        HashMap<String, Object> map =new HashMap<>();
        map.put("rfidCode",rfidCode);
        map.put("valueFlag","0");
        List<MeterBaseRfidInfo> models = meterBaseRfidInfoMapper.selectByMap(map);
        if(models.size() >= 1) {
            rm.setMessage("rfid已重复，不允许再次新增，请确认！！");
            return rm;
        }

        HashMap<String, Object> map1 =new HashMap<>();
        map1.put("carNo",carNo);
        map1.put("valueFlag","0");
        List<MeterBaseRfidInfo> models1 = meterBaseRfidInfoMapper.selectByMap(map1);
        if(models1.size() >= 1) {
            rm.setMessage("车号已重复，不允许再次新增，请确认！！");
            return rm;
        }
        MeterBaseRfidInfo meterBaseRfidInfo = meterBaseRfidInfoService.checkAndAdd(model);
        return success(meterBaseRfidInfo);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserfidinfo:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterBaseRfidInfo meterBaseRfidInfo = meterBaseRfidInfoService.getById(id);
        return success(meterBaseRfidInfo);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterBaseRfidInfo信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterBaseRfidInfo", value = "详细实体meterBaseRfidInfo", required = true, dataType = "MeterBaseRfidInfo")
    })
    //@RequiresPermissions("meterbaserfidinfo:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseRfidInfo model){
        model.setId(id);
        MeterBaseRfidInfo meterBaseRfidInfo = meterBaseRfidInfoService.modify(model);
        return success(meterBaseRfidInfo);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbaserfidinfo:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterBaseRfidInfoService.delete(ids);
    	}
      return success();
    }
}
